routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect('/home');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::get('/play', 'PlayController@index')->name('play');
Route::get('/join', 'JoinController@index')->name('join');
Route::get('/privacy', 'GdprController@index')->name('privacy');
Route::get('/search', 'SearchController@index')->name('search.index');

Route::resource('albums', 'AlbumController');
Route::resource('artists', 'ArtistController');
Route::resource('songs', 'SongController');
Route::get('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');
Route::put('/{type}/{id}/playlist', 'PlaylistController@addToPlaylist')->name('playlist.addToPlaylist');

Route::post('/songs/{id}/queue', 'SongController@enqueue')->name('songs.enqueue');
Route::delete('/songs/{id}/queue', 'SongController@dequeue')->name('songs.dequeue');
Route::delete('/queue', 'SongController@emptySession')->name('songs.flush');

Route::resource('playlists', 'PlaylistController');


Route::resource('profile', 'ProfileController', [
    'only' => ['edit', 'update', 'destroy'],
    'parameters' => ['profile' => 'user']
]);
Route::put('/profile/{id}/theme', 'ProfileController@updateTheme')->name('profile.updateTheme');

/**
 * Redirection
 */
Route::any('{query}', function () {
    return redirect('/home');
})->where('query', '.*');

app/Album.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Album extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'artist_id'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    public function songs()
    {
        return $this->hasMany('App\Song');
    }

    public function artist()
    {
        return $this->belongsTo('App\Artist');
    }

    public function getSongIdsAttribute()
    {
        return $this->songs->pluck('id');
    }
}

app/Http/Controllers/AlbumController.php
<?php

namespace App\Http\Controllers;

use App\Album;
use App\Repositories\AlbumRepository;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;

class AlbumController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param AlbumRepository $albumRepository
     * @param Request $request
     * @return Response
     */
    public function index(AlbumRepository $albumRepository, Request $request)
    {
        $q = null;

        if ($request->has('q')) {
            $validatedData = $request->validate([
                'q' => 'required|string'
            ]);

            $q = $validatedData['q'];
        }

        if (Auth::check()) {
            $albums = isset($q) ? $albumRepository->searchAlbums($q, Auth::user()->id) : $albumRepository->getAlbums(Auth::user()->id);
        } else {
            $albums = isset($q) ? $albumRepository->searchAlbums($q) : $albumRepository->getAlbums();
        }

        return view('albums.listing_albums', compact('albums'));
    }

    public function show(Album $album)
    {
        if (Auth::check()) {
            $songs = $album->songs()->where('songs.visibility', 'public')->orWhere('songs.visibility', 'private')->
            where('songs.user_id', Auth::user()->id)->where('songs.album_id', $album->id)->orderBy('songs.title', 'ASC')->paginate(5);
        } else {
            $songs = $album->songs()->where('songs.visibility', 'public')->where('songs.album_id', $album->id)->orderBy('songs.title', 'ASC')->paginate(5);
        }

        return view('albums.show_album', compact('album', 'songs'));
    }
}

app/Http/Controllers/ArtistController.php
<?php

namespace App\Http\Controllers;

use App\Artist;
use App\Repositories\ArtistRepository;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;

class ArtistController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param ArtistRepository $artistRepository
     * @param Request $request
     * @return Response
     */
    public function index(ArtistRepository $artistRepository, Request $request)
    {
        $q = null;

        if ($request->has('q')) {
            $validatedData = $request->validate([
                'q' => 'required|string'
            ]);

            $q = $validatedData['q'];
        }

        if (Auth::check()) {
            $artists = isset($q) ? $artistRepository->searchArtists($q, Auth::user()->id) : $artistRepository->getArtists(Auth::user()->id);
        } else {
            $artists = isset($q) ? $artistRepository->searchArtists($q) : $artistRepository->getArtists();
        }
        return view('artists.listing_artists', compact('artists'));
    }

    public function show(Artist $artist)
    {
        if (Auth::check()) {
            $songs = $artist->songs()->where('songs.visibility', 'public')->orWhere('songs.visibility', 'private')->
            where('songs.user_id', Auth::user()->id)->where('songs.artist_id', $artist->id)->orderBy('songs.title', 'ASC')->paginate(3);
        } else {
            $songs = $artist->songs()->where('songs.visibility', 'public')->where('songs.artist_id', $artist->id)->orderBy('songs.title', 'ASC')->paginate(3);
        }

        $albums = $artist->albums()->withCount('songs')->where('albums.artist_id', $artist->id)->paginate(3, ['*'], 'album_pagination');
        return view('artists.show_artist', compact('artist', 'songs', 'albums'));
    }
}

resources/views/albums/edit_album.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            @if(session()->has('message'))
                <div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ session()->get('message') }}
                </div>
            @endif
            @if($errors->any())
                <div class="alert alert-danger alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ $errors->first() }}
                </div>
            @endif
            <form action="{{ route('albums.update', $album->id)}}" method="POST">
                @method('PUT')
                @csrf

                <div class="d-flex">
                    <div class="media-body">
                        <a href="{{route('albums.index')}}" class="btn"><i>@svg('solid/angle-left',
                                'icon-white')</i></a>
                    </div>
                    <div class="align-self-center">
                        <input type="text" class="h3 m-0 bg-transparent border-0 text-white no-outline"
                               name="name"
                               value="{{$album->name}}">
                    </div>
                    <div class="media-body"></div>
                </div>
                @auth
                    <button type="submit" class="btn btn-impulsy btn-block mt-3">{{ __('Save changes') }}</button>
                @endauth
            </form>

            <ul class="list-unstyled mt-3">
                @foreach($album->songs as $song)
                    <li id="song_{{$song->id}}" class="media bg-transparent mb-2">
                        <i class="mr-3">@svg('list_title','icon-xl icon-pink')</i>
                        <div class="media-body">
                            <div class="float-right">
                                <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                            </div>
                            <a class="cursor-pointer" id="{{json_encode($song->id)}}_play"
                               onclick="play({{ json_encode($song->filename) }}, {{ json_encode($song->song_name) }})">
                                <h5 class="mt-0 mb-1 font-weight-bolder">{{ $song->song_name }}</h5>
                            </a>
                        </div>
                    </li>
                @endforeach
            </ul>
        </div>
    </div>
@endsection
@section('scripts')

@endsection

resources/views/albums/listing_albums.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            @if(session()->has('message'))
                <div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ session()->get('message') }}
                </div>
            @endif
            @if($errors->any())
                <div class="alert alert-danger alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ $errors->first() }}
                </div>
            @endif
            <div class="title-group">
                <h2 class="d-inline text-pink">{{ __('Albums') }}</h2>
            </div>
            <ul class="mt-3">
                @foreach($albums as $album)
                    <li class="media bg-transparent mb-2">
                        <i class="mr-3">@svg('list_album','icon-xl icon-pink')</i>
                        <div class="media-body">
                            <div class="float-right">
                                <div class="dropdown d-inline">
                                    <a id="addDropdown" href="#" role="button"
                                       data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                    </a>

                                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="addDropdown">
                                        <a class="dropdown-item" href="#"
                                           onclick="queue({{json_encode($album->getSongIdsAttribute())}})">
                                            {{ __('Add to queue') }}
                                        </a>

                                        @auth
                                            <a class="dropdown-item" href="#modalForm"
                                               data-href="{{route('playlist.addToPlaylist', ['type' => 'album', $album->id])}}"
                                               data-toggle="modal">
                                                {{ __('Add to playlist') }}
                                            </a>
                                        @endauth
                                    </div>
                                </div>
                                <a href="#"
                                   onclick="playAll({{json_encode($album->getSongIdsAttribute())}})">
                                    <i class="mr-3">@svg('solid/play', 'icon-sm icon-white')</i>
                                </a>
                            </div>
                            <a href="{{ route('albums.show', $album->id) }}">
                                <h5 class="mt-0 mb-1 font-weight-bolder cursor-pointer text-decoration-none">@if(!isset($album->name)) {{__('Unknown Album')}} @else {{ $album->name }} @endif</h5>
                            </a>
                            {{ $album->songs_count }} {{ __('Titles') }}.
                        </div>
                    </li>
                @endforeach
            </ul>
            <div class="mt-2">{{ $albums->appends(array_except(Request()->query(), 'page'))->links() }}</div>
        </div>
    </div>
@endsection
@section('scripts')

@endsection

resources/views/albums/show_album.blade.php
@extends('partials.iframe-tab')
@section('tab')
    <div class="row justify-content-center">
        <div class="col-md-12 mt-2">
            @if(session()->has('message'))
                <div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ session()->get('message') }}
                </div>
            @endif
            @if($errors->any())
                <div class="alert alert-danger alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                    {{ $errors->first() }}
                </div>
            @endif

            <div class="d-flex mt-3">
                <div class="media-body">
                    <a href="{{route('albums.index')}}" class="btn"><i>@svg('solid/angle-left',
                            'icon-white')</i></a>
                </div>
                <div class="align-self-center text-center">
                    <i class="d-block">@svg('list_album','icon-xxl icon-pink')</i>
                    <h3>{{$album->name}}</h3>
                </div>
                <div class="media-body"></div>
            </div>

            <ul class="list-unstyled mt-3">
                @foreach($songs as $song)
                    <li id="song_{{$song->id}}" class="media bg-transparent mb-2">
                        <i class="mr-3">@svg('list_title','icon-xl icon-pink')</i>
                        <div class="media-body">
                            <div class="float-right">
                                <div class="dropdown d-inline">
                                    <a id="addDropdown" href="#" role="button"
                                       data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="mr-3">@svg('solid/plus', 'icon-sm icon-white')</i>
                                    </a>

                                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="addDropdown">
                                        <a class="dropdown-item" href="#"
                                           onclick="enqueue({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                            {{ __('Add to queue') }}
                                        </a>

                                        @auth
                                            <a class="dropdown-item" href="#modalForm" data-href="{{route('playlist.addToPlaylist', ['type' => 'song', $song->id])}}" data-toggle="modal">
                                                {{ __('Add to playlist') }}
                                            </a>
                                        @endauth
                                    </div>
                                </div>
                            </div>
                            <a class="cursor-pointer" id="{{json_encode($song->id)}}_play"
                               onclick="play({{ json_encode(route('songs.enqueue', $song->id)) }})">
                                <h5 class="mt-0 mb-1 font-weight-bolder">{{ $song->title }}</h5>
                            </a>
                        </div>
                    </li>
                @endforeach
            </ul>
                <div
                    class="mt-2">{{ $songs->links() }}</div>
        </div>
    </div>
@endsection
@section('scripts')

@endsection